<script lang="ts">
import Vue from 'vue';
import {
  BusinessShowcase,
  DemoCta,
  DemoCtaCard,
  SolutionsCostCards,
  SolutionsPlatformTabLinks,
} from '../../solutions/index.vue';
import {
  AnalyticsInsightsCustomerSuccessCard,
  AnalyticsInsightsFeatured,
  AnalyticsInsightsShowcaseFaq,
} from '../analytics-and-insights/index.vue';
import {
  CardBasicStyle,
  Copy,
  CopyMedia,
  Faq,
  GroupButtons,
  IntegratedApplications,
  NewQuotesCarousel,
  NextStepAlt,
  PricingTiers,
  ReportCta,
  SideNavigationVariant,
  SlpBreadcrumb,
} from '../../common/index.vue';
import {
  DevExBenefits,
  DevExCards,
  DevExCarousel,
  DevExHero,
} from '../../developer-experience/index.vue';
import {
  BySolutionAccordeon,
  BySolutionBenefits,
  BySolutionCasestudies,
  BySolutionHero,
  BySolutionIntro,
  BySolutionLink,
  BySolutionListImage,
  BySolutionShowcase,
  BySolutionValueProp,
} from '../by-solution/index.vue';
import {
  ByIndustryCaseStudies,
  ByIndustryCtaShowcase,
  ByIndustryIntro,
  ByIndustrySolutionsBlock,
} from '../by-industry/index.vue';
import {
  OpenSourceBlog,
  OpenSourceFormSection,
  OpenSourcePartnersGrid,
  OverviewBlocks,
  PartnersGridFull,
} from '../../open-source/index.vue';
import { CarouselComponent as ByIndustryQuotesCarousel } from '../by-industry/quotes-carousel/index.vue';
import {
  CtaBlock,
  Fedramp,
  ResourceCarousel,
  SolutionsHero,
  SolutionsMetrics,
  SolutionsResourceCards,
  SolutionsVideoFeature,
  TierBlock,
} from '../index.vue';
import {
  Showcase as CompanyShowcase,
  CustomerLogos,
} from '../../devsecops/index.vue';
import { EducationCaseStudyCarousel } from '../education/index.vue';
import {
  StartupsIntro,
  StartupsLink,
  StartupsOverview,
} from '../startups/index.vue';
import {
  NonprofitIntro,
  NonprofitOverview,
  QuotesCarousel,
  SingleCtaBlock,
} from '../nonprofit/index.vue';
import { Recognition } from '../../platform/index.vue';
import { StsMarketoForm as SolutionsForm } from '~/components/dedicated/index.vue';

export default Vue.extend({
  name: 'IndustryTemplate',
  components: {
    AnalyticsInsightsFeatured,
    AnalyticsInsightsShowcaseFaq,
    AnalyticsInsightsCustomerSuccessCard,
    BusinessShowcase,
    CompanyShowcase,
    TierBlock,
    NextStepAlt,
    CardBasicStyle,
    CtaBlock,
    Copy,
    CopyMedia,
    DevExBenefits,
    DevExCards,
    DevExCarousel,
    DevExHero,
    Recognition,
    StartupsIntro,
    StartupsOverview,
    StartupsLink,
    BySolutionShowcase,
    SlpBreadcrumb,
    OpenSourceBlog,
    BySolutionHero,
    BySolutionValueProp,
    OpenSourcePartnersGrid,
    OverviewBlocks,
    EducationCaseStudyCarousel,
    BySolutionBenefits,
    SolutionsCostCards,
    SolutionsResourceCards,
    SolutionsVideoFeature,
    ResourceCarousel,
    NewQuotesCarousel,
    CustomerLogos,
    PricingTiers,
    BySolutionIntro,
    BySolutionAccordeon,
    PartnersGridFull,
    BySolutionCasestudies,
    BySolutionListImage,
    BySolutionLink,
    SideNavigationVariant,
    SolutionsHero,
    SolutionsMetrics,
    ByIndustryIntro,
    ByIndustryCaseStudies,
    ByIndustryQuotesCarousel,
    ByIndustrySolutionsBlock,
    ByIndustryCtaShowcase,
    GroupButtons,
    Faq,
    OpenSourceFormSection,
    ReportCta,
    QuotesCarousel,
    NonprofitOverview,
    SingleCtaBlock,
    NonprofitIntro,
    DemoCtaCard,
    DemoCta,
    IntegratedApplications,
    Fedramp,
    SolutionsForm,
    SolutionsPlatformTabLinks,
  },
  props: {
    solutions: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <div>
    <SlpContainer v-if="solutions.breadcrumbs">
      <SlpBreadcrumb :crumbs="solutions.breadcrumbs" />
    </SlpContainer>
    <component
      :is="component?.name"
      v-for="(component, index) in solutions?.components"
      :key="`${component?.name}-${index}`"
      :data="component.data"
      v-bind="component"
    >
      <slot v-if="component?.slot_enabled">
        <component
          :is="subcomponent?.name"
          v-for="(subcomponent, item) in component.slot_content"
          :key="item"
          v-bind="subcomponent"
        >
          <slot v-if="subcomponent?.slot_enabled">
            <component
              :is="contents?.name"
              v-for="(contents, subitem) in subcomponent.slot_content"
              :key="subitem"
              v-bind="contents"
            />
          </slot>
        </component>
      </slot>
    </component>
    <NextStepAlt />
  </div>
</template>

<style scoped lang="scss">
div[role='main'] {
  overflow: clip;
}
</style>
